// ACM 2006
// Problem E. Ecology
// Sergio A. Fjodorov

//    l

{$apptype console}

uses
  Classes;

  function CompareTreeItems(A, B: pointer): integer;
  begin
    Result := integer(A) - integer(B);
  end;

var
  i, j, n, l, t: integer;
  step, delta: integer;
  m: integer;
  trees: TList;
  ms, s: int64;

begin
  Assign(input, 'input.txt');
  Assign(output, 'output.txt');
  Reset(input);
  Rewrite(output);

  trees := TList.Create;
  try
    Read(n, l);

    for i := 1 to n do begin
      Read(t);
      trees.Add(Ptr(t mod l));
    end;

    trees.Sort(CompareTreeItems);

    s := 0;
    m := 0;
    ms := 0;

    i := n - 1;
    step := 0;
    while i >= 0 do begin
      j := i;
      while (i >= 0) and (trees[i] = trees[j]) do Dec(i);

      delta := l - integer(trees[j]) - step;
      Inc(step, delta);

      Inc(s, delta * n); 
      Dec(s, (j - i) * l);

      if ms > s then begin
        ms := s;
        m := step;
      end;
    end;

    WriteLn(m);
  finally
    trees.Free;
  end;

  Close(input);
  Close(output);
end.
